//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    NlmaPeriod       = 13;
extern int    MacdFastPeriod   = 12;
extern int    MacdSlowPeriod   = 26;
extern int    MacdSignalPeriod =  9;
extern int    Price            = PRICE_CLOSE;

//
//
//
//
//

double impulseDn[];
double impulseUp[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,impulseDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,impulseUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(timeFrame)+" Elder impulse");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];
#define _nlma  0
#define _macdv 1
#define _macds 2
#define _macdo 3

//
//
//
//
//

int start()
{
   double cOpen,cClose;
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { impulseDn[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_EMA,Price,i);
            work[r][_nlma]  = iNonLagMa(price,NlmaPeriod,i,0); 
            work[r][_macdv] = iNonLagMa(price,MacdFastPeriod,i,1)-iNonLagMa(price,MacdSlowPeriod,i,2);
            work[r][_macds] = iNonLagMa(work[r][_macdv],MacdSignalPeriod,i,3);
            work[r][_macdo] = work[r][_macdv]-work[r][_macds];
   
         //
         //
         //
         //
         //
         
         impulseDn[i]=EMPTY_VALUE;
         impulseUp[i]=EMPTY_VALUE;
         trend[i]    =EMPTY_VALUE;
               cOpen  = Open[i];
               cClose = Close[i];
         if (work[r][_nlma]<work[r-1][_nlma] && work[r][_macdo]<work[r-1][_macdo]) trend[i] = -1;
         if (work[r][_nlma]>work[r-1][_nlma] && work[r][_macdo]>work[r-1][_macdo]) trend[i] =  1;
         if (trend[i] == -1) { impulseDn[i]=MathMax(cClose,cOpen); impulseUp[i]=MathMin(cClose,cOpen); }       
         if (trend[i] ==  1) { impulseDn[i]=MathMin(cClose,cOpen); impulseUp[i]=MathMax(cClose,cOpen); }
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NlmaPeriod,MacdFastPeriod,MacdSlowPeriod,MacdSignalPeriod,Price,2,y);
         impulseDn[i] = EMPTY_VALUE;
         impulseUp[i] = EMPTY_VALUE;

            cOpen  = Open[i];
            cClose = Close[i];

      if (trend[i] == -1) { impulseDn[i]=MathMax(cClose,cOpen); impulseUp[i]=MathMin(cClose,cOpen); }       
      if (trend[i] ==  1) { impulseDn[i]=MathMin(cClose,cOpen); impulseUp[i]=MathMax(cClose,cOpen); }
   }
   return(0);         
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

#define numOfSeparateCalculations 4
double  nlmvalues[numOfSeparateCalculations][3];
double  nlmprices[ ][numOfSeparateCalculations];
double  nlmalphas[ ][numOfSeparateCalculations];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(nlmprices,0) != Bars)         ArrayResize(nlmprices,Bars);
   if (ArrayRange(nlmvalues,0) <  instanceNo+1) ArrayResize(nlmvalues,instanceNo+1); r = Bars-r-1;
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length  || ArraySize(nlmalphas)==0)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  
         nlmvalues[instanceNo][_weight] = 0;

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo]        = g * beta;
            nlmvalues[instanceNo][_weight] += nlmalphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_weight]>0)
   {
      double sum = 0;
           for (k=0; k < nlmvalues[instanceNo][_len]; k++) sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo];
           return( sum / nlmvalues[instanceNo][_weight]);
   }
   else return(0);           
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}